const parser = require("@babel/parser");
const traverse = require("@babel/traverse").default;
const core = require("@babel/core");
const visitor = require('./visitor');

function compile(source) {
  // 1、解析
  var ast = parser.parse(source, {
    sourceType: "module",
    plugins: ["dynamicImport"]
  });
  
  // 2、遍历（深度优先）
  traverse(ast, visitor);
  
  // 3、生成source源码
  return core.transformFromAstSync(ast, null, {
    configFile: false
  }).code;
}

module.exports = compile;